unit Registry_Func;

Interface

Function IsInIDE: Boolean;
Function CheckOS: Integer;  // Betriebssystemplattform ermitteln
Function GetOwnComputerName: String;
Function APPistheShell: Boolean;
Function GetMD: Boolean; //True if month is first
Function GetSdate: Char; //Date separator character
Function GetStime: String; //Time separator character
Function GetSdecimal: Char; //Number decimal character
Function GetShortDate(FillZeros: Boolean): String;

implementation

uses
 Windows, Forms, VersionInfo, SysUtils, Registry, StrUtils,
 Dialogs, String_Func;

// Hkey cache (used for logging purposes)
Type HKEY_CACHE = Record
 hkey   : Integer;
 strHkey: String;
End;

Function IsInIDE: Boolean;
begin
 Result:= (FindWindow('TAppBuilder', nil) > 0);
end;

Function CheckOS: Integer;  // Betriebssystemplattform ermitteln
 {Returns
   VER_PLATFORM_WIN32s = 0;
   VER_PLATFORM_WIN32_WINDOWS = 1;
   VER_PLATFORM_WIN32_NT = 2;  }
var
 VerInfo: TOSVersionInfo;
begin
 VerInfo.dwOSVersionInfoSize:= sizeof(VerInfo);
 if (GetVersionEx(VerInfo)) then
  Result:= VerInfo.dwPlatformId
 else
  Result:= 0;
end;

Function GetOwnComputerName: String;
var
 Ca   : Array[0..255] of char;
 nSize: DWord;
begin
 nSize:= length(Ca);
 GetComputerName(@Ca , nSize);
 if nSize > 0 then
  SetString(Result, Ca, nSize)
 else
  Result:= '';
End;

Function APPistheShell: Boolean;
 //Returns TRUE if the current EXE program is the Shell
var
 Reg: TRegistry;
 ResultStr: String;
Const
 gReaderPath = 'software\microsoft\windows NT\currentVersion\winlogon';
 gPathKey = 'shell'; //==> Standardeintrag lesen
begin
 Result:= false;
 If CheckOS = 2 Then //NT
 begin
  Reg:= Tregistry.Create;
  ResultStr:= '';
  try
   Reg.RootKey:= HKEY_LOCAL_MACHINE;
   Reg.Access:= Key_Read;
   Reg.OpenKeyReadOnly(gReaderPath);
   ResultStr:= Reg.ReadString(gPathKey);
   Result:= (InString(1, UpperCase(Resultstr), Uppercase(Application.EXEName + '.EXE')) > 0);
  finally
   Reg.Free;
  end;
 End;
End;

Function GetShortDate(FillZeros: Boolean): String;
var
 Reg      : TRegistry;
 ResultStr: String;
 SS       : String;
 x        : Integer;
Const
 gReaderPath = 'Control Panel\International';
 gPathKey    ='Sshortdate'; //==> Standardeintrag lesen
begin
 Reg:=Tregistry.Create;
 Resultstr:='dd.MM.yyyy';
 try
  Reg.RootKey:=HKEY_CURRENT_USER;
  Reg.Access:= Key_Read;
  Reg.OpenKeyReadOnly(gReaderPath);
  ResultStr:=Reg.ReadString(gPathKey);
 finally
  Reg.Free;
 end;
 If FillZeros Then
  For x:= 1 To Length(ResultStr) do
   If ResultStr[x] <> SS Then ResultStr[x]:= '0';
 Result:= ResultStr;
End;

Function GetMD: Boolean;
var
 Reg      : TRegistry;
 ResultStr: String;
Const
 gReaderPath = 'Control Panel\International';
 gPathKey ='Sshortdate'; //==> Standardeintrag lesen
begin
 Reg:=Tregistry.Create;
 Resultstr:='dd.MM.yyyy';
 try
  Reg.RootKey:= HKEY_CURRENT_USER;
  Reg.Access:= Key_Read;
  Reg.OpenKeyReadOnly(gReaderPath);
  ResultStr:=Reg.ReadString(gPathKey);
 finally
  Reg.Free;
 end;
 If Resultstr = '' Then
  Result:=False
 Else
  Result:=(Uppercase(Resultstr[1]) = 'M');
End;

Function GetSdate: Char;
var
 Reg      : TRegistry;
 ResultStr: String;
Const
 gReaderPath = 'Control Panel\International';
 gPathKey    ='Sdate'; //==> Standardeintrag lesen
begin
 Reg:=Tregistry.Create;
 try
  Reg.RootKey:= HKEY_CURRENT_USER;
  Reg.Access:= Key_Read;
  Reg.OpenKeyReadOnly(gReaderPath);
  ResultStr:= Reg.ReadString(gPathKey);
 finally
  Reg.Free;
 end;
 If Resultstr = '' Then
  Result:= '.'
 Else
  Result:= Resultstr[1];
End;

Function GetSdecimal: Char;
var
 Reg      : TRegistry;
 ResultStr: String;
Const
 gReaderPath = 'Control Panel\International';
 gPathKey    = 'Sdecimal'; //==> Standardeintrag lesen
begin
 Reg:=Tregistry.Create;
 try
  Reg.RootKey:= HKEY_CURRENT_USER;
  Reg.Access:= Key_Read;
  Reg.OpenKeyReadOnly(gReaderPath);
  ResultStr:= Reg.ReadString(gPathKey);
 finally
  Reg.Free;
 end;
 If Resultstr = '' Then
  Result:= '.'
 Else
  Result:= Resultstr[1];
End;

Function GetStime: String;
var
 Reg      : TRegistry;
 ResultStr: String;
Const
 gReaderPath = 'Control Panel\International';
 gPathKey    = 'Stime'; //==> Standardeintrag lesen 
begin
 Reg:=Tregistry.Create;
 try
  Reg.RootKey:= HKEY_CURRENT_USER;
  Reg.Access:= Key_Read;
  Reg.OpenKeyReadOnly(gReaderPath);
  ResultStr:= Reg.ReadString(gPathKey);
 finally
  Reg.Free;
 end;
 If Resultstr = '' Then
  Result:= ':'
 Else
  Result:= Resultstr;
End;

end.
