unit VersionInfo;

{ Taken from Help of Innosetup
Windows versions:

4.0.950 Windows 95
4.0.1111 Windows 95 OSR 2 & OSR 2.1
4.0.1212 Windows 95 OSR 2.5
4.10.1998 Windows 98
4.10.2222 Windows 98 Second Edition
4.90.3000 Windows Me

Windows NT versions:

4.0.1381 Windows NT 4.0
5.0.2195 Windows 2000
5.1.2600 Windows XP
         or Windows XP 64-Bit Edition Version 2002 (Itanium)
5.2.3790 Windows Server 2003
         or Windows XP x64 Edition (AMD64/EM64T)
         or Windows XP 64-Bit Edition Version 2003 (Itanium)
6.0.6000 Windows Vista
6.0.6001 Windows Vista with Service Pack 1 or Windows Server 2008
6.1.7600 Windows 7 or Windows Server 2008 R2
}
interface

uses
 Windows, Dialogs, Messages, SysUtils, Forms,

 String_Func;

Type viInfo = (viCompanyName, viFileDescription, viFileVersion, viInternalName,
               viLegalCopyright, viLegalTradeMarks, viOriginalFilename,
               viProductName, viProductVersion, viComments, viAppMajorVer, viAppMinorVer,
               viAppRelVer, viAppBuild);
var
 ApplicationInfo: viInfo;
 OS_VersionText : String;

Function GetApplicationInfo(viKey: viInfo): String;

implementation

Function GetApplicationInfo(viKey: viInfo): String;
var
 S       : String;
 Len, n  : DWORD;
 i, Index: Integer;
 Buf     : Pointer;
 Value   : PChar;
const
 InfoStr:array [0..13] of String =
    ('CompanyName', 'FileDescription', 'FileVersion', 'InternalName',
     'LegalCopyright', 'LegalTradeMarks', 'OriginalFilename',
     'ProductName', 'ProductVersion', 'Comments', 'AppMajorVer', 'AppMinorVer',
     'AppRelVer', 'AppBuild');
begin
 S:= Application.ExeName;
 n:= GetFileVersionInfoSize(PChar(S), n);
 if n > 0 then
 begin
  Buf:= AllocMem(n);
  GetFileVersionInfo(PChar(S), 0, n, Buf);
  Index:= Ord(viKey);
  S:= '';
  If Index in [10..13] then
  begin //English USA ?
   if VerQueryValue(Buf, PChar('\StringFileInfo\040904E4\' + InfoStr[2]),
                    Pointer(Value), Len) then
    S:= strpas(Value)
   else //German ?
    if VerQueryValue(Buf, PChar('\StringFileInfo\040704E4\' + InfoStr[2]),
                     Pointer(Value), Len) then
     S:= StrPas(Value)
    else
     S:= '0.0.0.0.0';
   Case Index of
    10:S:= copy(S, 1, pos('.', S) -1); //AppMajorVersion
    11:begin //AppMinorVersion
        i:= pos('.', S); //Punkt vor Minor Version
        Inc(i, 1);
        S:= copy(S, i, instring(i, S, '.') - i);
       end;
    12:begin //AppReleaseVersion
        i:= InString(pos('.', S) +1, S, '.'); //Punkt vor Minor Version
        Inc(i, 1);
        S:= copy(S, i, InString(i, S, '.') - i);
       end;
    13:begin //AppBuild
        i:= InString(pos('.' ,S) +1, S, '.'); //Punkt vor Minor Version
        Inc(i, 1);
        i:= InString(i, S, '.'); //Punkt vor Release
        Inc(i, 1);
        S:= copy(S, i, length(s));
       end
   end;
   Result:= S;
  end
  else
  begin //English USA ?
   if VerQueryValue(Buf, PChar('\StringFileInfo\040904E4\' + InfoStr[Index]),
                    Pointer(Value), Len) then
    Result:= strpas(Value)
   else //German ?
    if VerQueryValue(Buf, PChar('\StringFileInfo\040704E4\' + InfoStr[Index]),
                     Pointer(Value), Len) then
     Result:= StrPas(Value)
    else
     Result:= '';
  end;
  FreeMem(Buf, n);
 end
 else
  Result:= '';
end;

begin //Get OS Version Info when initializinf unit
 Case Win32Platform of
  VER_PLATFORM_WIN32s:
   OS_VersionText:= 'Windows 3.1';
  VER_PLATFORM_WIN32_WINDOWS:
   Case Win32MajorVersion of
    4: Case Win32MinorVersion of
         0: OS_VersionText:= 'Windows 95';
        10: OS_VersionText:= 'Windows 98';
        90: OS_VersionText:= 'Windows ME';
        else

       end;
   end;
  VER_PLATFORM_WIN32_NT: //NT 4 oder 5
   Case Win32MajorVersion of
    3: OS_VersionText:= 'Windows NT 3.' + IntToStr(Win32MinorVersion);
    4: OS_VersionText:= 'Windows NT 4';
    5: Case Win32MinorVersion of
        0: OS_VersionText:= 'Windows 2000';
        1: OS_VersionText:= 'Windows XP';
        2: OS_VersionText:= 'Windows XP Server 2003';
       end;
    6: Case Win32MinorVersion of
        0: OS_VersionText:= 'Windows Vista';
        1: OS_VersionText:= 'Windows 7 or Windows Server 2008';
       end;
   end;
 End;
end.
