unit main;

interface

uses
  Windows, SysUtils, Messages, Controls, Forms, Dialogs, StdCtrls, ExtCtrls,
  Buttons, wclConnections, wclServers, wclAPI, wclBluetoothDiscovery, Classes,
  ComCtrls;

type
  TfmMain = class(TForm)
    wclAPI: TwclAPI;
    wclBluetoothDiscovery: TwclBluetoothDiscovery;
    wclServer: TwclServer;
    PageControl1: TPageControl;
    Client_FU: TTabSheet;
    TabSheet2: TTabSheet;
    btListen: TButton;
    btClose: TButton;
    wclClient: TwclClient;
    btConnect: TButton;
    tDisconnect: TButton;
    btDiscover: TButton;
    lvDevices: TListView;
    Timer1: TTimer;
    GroupBox2: TGroupBox;
    ListBox1: TListBox;
    GroupBox1: TGroupBox;
    Richtung: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label8: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Edit1: TEdit;
    ScrollBar1: TScrollBar;
    ScrollBar2: TScrollBar;
    Panel1: TPanel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    CheckBox1: TCheckBox;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label20: TLabel;
    Edit12: TEdit;
    GroupBox3: TGroupBox;
    Label18: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Edit10: TEdit;
    Edit13: TEdit;
    Edit14: TEdit;
    Edit15: TEdit;
    GroupBox4: TGroupBox;
    Label24: TLabel;
    Edit16: TEdit;
    Label25: TLabel;
    Edit17: TEdit;
    GroupBox5: TGroupBox;
    Label16: TLabel;
    Label17: TLabel;
    Edit8: TEdit;
    Edit9: TEdit;
    ProgressBar1: TProgressBar;
    Timer2: TTimer;
    Label19: TLabel;
    Edit11: TEdit;
    Memo1: TMemo;
    Memo2: TMemo;

    //****** Common ******
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);

    //****** Server ******
    procedure btListenClick(Sender: TObject);
    procedure btCloseClick(Sender: TObject);
    procedure wclServerClosed(Sender: TObject);
    procedure wclServerConnected(Sender: TObject);
    procedure wclServerDisconnected(Sender: TObject);
    procedure wclServerListen(Sender: TObject; Error: Integer);
    procedure wclServerData(Sender: TObject; Buffer: Pointer;Size: Cardinal);

    //****** Client ******
    procedure btConnectClick(Sender: TObject);
    procedure tDisconnectClick(Sender: TObject);
    procedure wclClientConnect(Sender: TObject; Error: Integer);
    procedure wclClientDisconnect(Sender: TObject);
    procedure wclClientData(Sender: TObject; Buffer: Pointer; Size: Cardinal);
    procedure wclBluetoothDiscoveryDiscoveryStarted(Sender: TObject; Radio: TwclBluetoothRadio);
    procedure wclBluetoothDiscoveryDiscoveryComplete(Sender: TObject; Radio: TwclBluetoothRadio; Devices: TwclBluetoothDevices);
    procedure btDiscoverClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure ScrollBar2Change(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure PageControl1Changing(Sender: TObject; var AllowChange: Boolean);
    procedure Timer2Timer(Sender: TObject);

  private
    RxBuff                 : Array of Byte;
    TxBuff                 : Array[0..80] of Byte;
    TxVar1, TxVar2, TxVar3,
    TxVar4, TxVar5, TxVar6,
    TxVar7, TxVar8         : SmallInt;
    Spannung, Strom        : SmallInt;
    TxSubParID, SubParID,
    Richtg,
    PWM                    : Byte;
  const
    Msg254NumByte = 70;
    StdMsgNumByte = 7;
    MotorID = 72;

    function GetSelectedRadio: TwclBluetoothRadio;
    Procedure DecodeRxData;
    Procedure MakeBCC(Byte2Add: Byte);
    Procedure Add2ListBox1(S: String);
  end;

var
 fmMain: TfmMain;

implementation

{$R *.dfm}

uses
 wclErrors, wclUUIDs, ComObj, INI_File, RealGlobals;

//********************************* General *********************************
procedure TfmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 tDisconnectClick(Sender);
 wclServer.Close;

 WriteSetting('General', 'Form_Left_Pos', IntToStr(Self.Left));
 WriteSetting('General', 'Form_Top_Pos', IntToStr(Self.Top));
 WriteSetting('General', 'Connect_To', Edit7.Text);
end;

procedure TfmMain.FormCreate(Sender: TObject);
var
 I: Integer;
begin
 wclAPI.Load;
 ScrollBar1Change(Sender);
 ScrollBar2Change(Sender);
 Edit6.Text:= IntToStr(Timer1.Interval);
 TxSubParID:= 0;
 PageControl1Change(Sender);

 ChDir(ExtractFilePath(Application.ExeName));

 //Avoid empty Ttitle
 If Application.Title = '' then Application.Title:= 'BT_Client_Server';

 INI_Name:= IncludeTrailingBackslash(GetMyDocumentsFolderName + '\' +
                                Application.Title) + Application.Title + '.INI';
 ForceDirectories(ExtractFilePath(INI_Name));

 I:= 20;
 LoadIntFromINI('General', 'Form_Left_Pos', Screen.WorkAreaLeft, Screen.Width - 100, I);
 Self.Left:= I;

 I:= 20;
 LoadIntFromINI('General', 'Form_Top_Pos', Screen.WorkAreaTop, Screen.Height - 100, I);
 Self.Top:= I;

 Edit7.Text:= Uppercase(GetSetting('General', 'Connect_To'));
end;

procedure TfmMain.FormDestroy(Sender: TObject);
begin
 wclAPI.Unload;
end;

procedure TfmMain.ScrollBar1Change(Sender: TObject);
begin
 Label1.Caption := IntToStr(ScrollBar1.Position);
end;

procedure TfmMain.ScrollBar2Change(Sender: TObject);
begin
 Label3.Caption := IntToStr(ScrollBar2.Position);
end;

Procedure TfmMain.MakeBCC(Byte2Add: Byte);
var
 x: Byte;
begin
 TxBuff[Byte2Add + 1]:= 0;  //BCC
 For x:= 0 to Byte2Add do
  TxBuff[Byte2Add + 1]:= TxBuff[Byte2Add + 1] + TxBuff[x];
end;

Procedure TfmMain.DecodeRxData;
var
 S: String;
 x: Integer;
 sI: SmallInt;
begin
 S:= '';
 For x:= 0 to Length(RxBuff) do S:= S + Format('%2.2X ', [RxBuff[x]]);
 Add2ListBox1(S);

 Case PageControl1.ActivePageIndex of
  0: begin  //Client
      Edit15.Text:= Format('%2.2X', [RxBuff[0]]); //Adresse
      Richtg:= RxBuff[1];
      PWM:= RxBuff[2];
      SubParID:= RxBuff[3];

      Edit13.Text:= IntToStr(Richtg);
      Edit14.Text:= IntToStr(PWM);
      Edit10.Text:= IntToStr(SubParID);

      //Transmit Message
      If PageControl1.ActivePageIndex = 0 then
      begin //Client
       If SubParID = 254 then
       begin
        TxVar1:= 10 + Random(5);
        TxVar2:= 20 + Random(5);
        TxVar3:= 30 + Random(5);
        TxVar4:= 40 + Random(5);
        TxVar5:= 50 + Random(5);
        TxVar6:= 60 + Random(5);
        TxVar7:= 70 + Random(5);
        TxVar8:= 80 + Random(5);

        //Copy TxVar1...TxVar8 to TxBuff
        CopyMemory(@TxBuff[0], @TxVar1, 16);
        for x:= 17 to Msg254NumByte do TxBuff[x]:= 0;
        MakeBCC(Msg254NumByte);
        Edit7.Text:= Format('%2.2x', [TxBuff[0]]);
        For x:= 1 to Msg254NumByte + 1 do Edit7.Text:= Edit7.Text + ' ' + Format('%2.2x', [TxBuff[x]]);
        If wclClient.State = csConnected then
         wclShowError(wclClient.Write(@TxBuff[0], Msg254NumByte));
       end
       else
       begin
        TxBuff[0]:= MotorID;

        try
         sI:= StrToInt(Edit16.Text);  //Spannung
        except
         sI:= 0;
        end;
        CopyMemory(@TxBuff[1], @sI, 2);

        try
         sI:= StrToInt(Edit17.Text);  //Strom
        except
         sI:= 0;
        end;
        CopyMemory(@TxBuff[3], @sI, 2);

        MakeBCC(StdMsgNumByte);

        If wclClient.State = csConnected then
         wclShowError(wclClient.Write(@TxBuff[0], StdMsgNumByte));
       end;
      end;
     end;
  1: begin  //Server
      CopyMemory(@Spannung, @RxBuff[1], 2);
      CopyMemory(@Strom, @RxBuff[3], 2);

      Edit8.Text:= IntToStr(Spannung);
      Edit9.Text:= IntToStr(Strom);
     end;
 End;
end;

function TfmMain.GetSelectedRadio: TwclBluetoothRadio;
var
 Radios: TwclBluetoothRadios;
begin
 Result := nil;
 Radios := TwclBluetoothRadios.Create;
 if (not wclShowError(wclBluetoothDiscovery.EnumRadios(Radios))) and (Radios.Count > 0) then begin
  Result := TwclBluetoothRadio.Create;
  Result.Assign(Radios[0]);
 end;
 Radios.Free;
 if not Assigned(Result) then MessageDlg('No Bluetooth API was found.', mtWarning, [mbOK], 0);
end;

Procedure TfmMain.Add2ListBox1(S: String);
begin
 ListBox1.Items.Insert(0, DateTimeToStr(now) + ' ' + S);
end;

//********************************* Server *********************************

procedure TfmMain.btListenClick(Sender: TObject);
var
 Radio: TwclBluetoothRadio;
begin
 if wclServer.State <> ssClosed then
   MessageDlg('Server is active', mtWarning, [mbOK], 0)
 else begin
  Radio := GetSelectedRadio;
  if Assigned(Radio) then begin
   wclServer.BluetoothParams.Radio := Radio;
   wclServer.BluetoothParams.Service := StringToGuid('{71D47FA1-87B6-4629-AB78-77B482AE5316}');
   wclShowError(wclServer.Listen);
   Radio.Free;
  end;
 end;
end;

procedure TfmMain.wclServerData(Sender: TObject; Buffer: Pointer; Size: Cardinal);
begin
 SetLength(RxBuff, Size);
 CopyMemory(@RxBuff[0], Buffer, Size);
 DecodeRxData;
end;

procedure TfmMain.PageControl1Change(Sender: TObject);
begin
 Case PageControl1.ActivePageIndex of
  0: begin
      Timer1.Enabled:= False;  //Client
      Edit11.Text:= 'disabled';
     end;
  1: begin
      Timer1.Enabled:= True;   //Server
      Edit11.Text:= 'enabled';
     end;
 end;
end;

procedure TfmMain.PageControl1Changing(Sender: TObject;
                                       var AllowChange: Boolean);
begin
 Case Pagecontrol1.ActivePageIndex of
  0: tDisconnectClick(Sender);
  1: btCloseClick(Sender);
 end;
 AllowChange:= True;
end;

procedure TfmMain.btCloseClick(Sender: TObject);
begin
 wclServer.Close;
end;

procedure TfmMain.wclServerClosed(Sender: TObject);
begin
 Add2ListBox1('Closed');
end;

procedure TfmMain.wclServerConnected(Sender: TObject);
begin
 Add2ListBox1('Connected: ' + wclServer.Address + ' ' + wclServer.DeviceName);
end;

procedure TfmMain.wclServerDisconnected(Sender: TObject);
begin
 Add2ListBox1('Disconnected ' + wclServer.Address + ' ' + wclServer.DeviceName);
end;

procedure TfmMain.wclServerListen(Sender: TObject; Error: Integer);
begin
 Add2ListBox1('Listen: ' + IntToStr(Error));
end;

procedure TfmMain.Timer1Timer(Sender: TObject);
var
 x : Byte;
 sI: SmallInt;
begin
 Timer1.Enabled:= False;
 If PageControl1.ActivePageIndex = 1 then
 begin //Server
  TxBuff[0]:= MotorID;
  TxBuff[1]:= ScrollBar1.Position; //Richtung
  TxBuff[2]:= ScrollBar2.Position; //PWM

  If CheckBox1.Checked then
  begin
   TxBuff[3]:= 254;
   CheckBox1.Checked:= False;
  end
  else
   TxBuff[3]:= TxSubParID;

  sI:= 0; //Default
  try
   Case TxSubParID of
    0: sI:= StrToInt(Edit2.Text);
    1: sI:= StrToInt(Edit3.Text);
    2: sI:= StrToInt(Edit4.Text);
    3: sI:= StrToInt(Edit5.Text);
   End;
  except
   //
  end;

  TxBuff[4]:= Lo(sI);
  TxBuff[5]:= Hi(sI);
  TxBuff[6]:= 0;

  Inc(TxSubParID);
  If TxSubParID > 3 then TxSubParID:= 0;
  MakeBCC(StdMsgNumByte);
  Edit1.Text:= Format('%2.2x', [TxBuff[0]]);
  For x:= 1 to StdMsgNumByte + 1 do Edit1.Text:= Edit1.Text + ' ' + Format('%2.2x', [TxBuff[x]]);
  If wclServer.State = ssConnected then
   wclShowError(wclServer.Write(@TxBuff[0], StdMsgNumByte + 1));
 end;
 Timer1.Enabled:= True;
end;

procedure TfmMain.Timer2Timer(Sender: TObject);
begin
 ProgressBar1.Position:= ProgressBar1.Position + 1;
end;

//********************************* Client *********************************
procedure TfmMain.btConnectClick(Sender: TObject);
var
 Radio: TwclBluetoothRadio;
 x    : Integer;
 Found: Integer;
begin
 if wclClient.State <> csDisconnected then
 begin
  Add2ListBox1('Client is active');
  Exit;
 end;

 Radio := GetSelectedRadio;
 Add2ListBox1('Connect started...');
 Found:= -1;
 If Edit7.Text > '' then
 begin
  //is desired server in Listbox?
  for x:= 0 to lvDevices.Items.Count - 1 do
   If Edit7.Text = lvDevices.Items[x].SubItems[0] then
   begin
    Found:= x;
    wclClient.BluetoothParams.Address:= lvDevices.Items[x].Caption;
    wclClient.BluetoothParams.Radio:= Radio;
   end;
 end;
 
 If Assigned(Radio) then
 begin
  if (Found = -1) and (not Assigned(lvDevices.Selected)) then
   MessageDlg('Select device', mtError, [mbOK], 0)
  else
  begin
   if (Found = -1) then Edit7.Text:= lvDevices.Selected.SubItems[0];

   If Assigned(lvDevices.Selected) then
   begin
    Add2ListBox1('Device Name: ' + Edit7.Text);
    wclClient.BluetoothParams.Address:= lvDevices.Selected.Caption;
    wclClient.BluetoothParams.Radio:= Radio;
   end;
   wclClient.BluetoothParams.Service:= StringToGUID('{71D47FA1-87B6-4629-AB78-77B482AE5316}');
   wclShowError(wclClient.Connect);
  end;
 end;
 Radio.Free;
end;

procedure TfmMain.tDisconnectClick(Sender: TObject);
begin
 wclClient.Disconnect;
end;

procedure TfmMain.wclClientConnect(Sender: TObject; Error: Integer);
begin
 if Error = WCL_E_SUCCESS then
  Add2ListBox1('Connected to: ' + Edit7.Text)
 else
  MessageDlg('Unable connect. Error: ' + IntToStr(Error), mtError, [mbOK], 0);
end;

procedure TfmMain.wclClientDisconnect(Sender: TObject);
begin
 Add2ListBox1(Edit7.Text + ' disconnected');
end;

procedure TfmMain.wclClientData(Sender: TObject; Buffer: Pointer; Size: Cardinal);
begin
 SetLength(RxBuff, Size);
 CopyMemory(@RxBuff[0], Buffer, Size);
 DecodeRxData;
end;

procedure TfmMain.wclBluetoothDiscoveryDiscoveryStarted(Sender: TObject; Radio: TwclBluetoothRadio);
begin
 lvDevices.Items.Clear;
 Add2ListBox1('Discover started...');
 Screen.Cursor:= crHourglass;
 ProgressBar1.Visible:= True;
 ProgressBar1.Position:= 1;
 Timer2.Enabled:= True;
end;

procedure TfmMain.wclBluetoothDiscoveryDiscoveryComplete(Sender: TObject; Radio: TwclBluetoothRadio; Devices: TwclBluetoothDevices);
var
 I, Res: Integer;
 Item  : TListItem;
 aName : WideString;
begin
 Screen.Cursor:= crdefault;
 Timer2.Enabled:= False;
 ProgressBar1.Visible:= False;
 if not Assigned(Devices) then
   MessageDlg('Discovery complete with error', mtError, [mbOK], 0)
 else
 begin
  Add2ListBox1('Discover completed...');
  if Devices.Count = 0 then
   MessageDlg('Nothing found', mtInformation, [mbOK], 0)
  else
  begin
   for I := 0 to Devices.Count - 1 do begin
    Item := lvDevices.Items.Add;
    Item.Caption := Devices[I].Address;
    Res := Devices[I].GetName(Radio, aName);
    if Res = WCL_E_SUCCESS then
     Item.SubItems.Add(aName)
    else
     Item.SubItems.Add('Error ' + IntToStr(Res));
   end;
   btConnectClick(Sender);
  end;
 end;
end;

procedure TfmMain.btDiscoverClick(Sender: TObject);
var
 Radio: TwclBluetoothRadio;
begin
 Radio:= GetSelectedRadio;
 If Assigned(Radio) then
 begin
  wclShowError(wclBluetoothDiscovery.Discovery(Radio));
  Radio.Free;
 end;
end;

end.
